# Tcl Wiki Server - $Id: file.tcl,v 1.2 2000/08/14 09:54:57 mbl Exp $
# 
# Copyright (c) 1997-99 Michel Beaudouin-Lafon, mbl@daimi.au.dk
# See the file "licence" for information on usage and redistribution
# of this file, and for a DISCLAIMER OF ALL WARRANTIES.

# Wiki page type handler
#	this file must be loaded into the Wiki namespace
#
# ----------------
# file type
# ----------------
#
proc file-EditFormAttr {pageVar} {
	return "enctype=multipart/form-data"
}

proc file-EditForm {pageVar} {
	upvar $pageVar thePage
	GetSite $thePage(site) theSite
	
	# file selection field to specify file name
	cgi_puts [Dict theSite uploadLabel]
	cgi_file_button content size=40
}

proc file-SavePage {pageVar} {
	upvar $pageVar thePage

	UploadContentFile thePage _files
	return ""
}

proc file-PreviewPage {pageVar} {
	upvar $pageVar thePage
	
	# ### should clear _preview directory when we're done, or when restarting the server
	UploadContentFile thePage _preview
	return ""
}

proc file-Page2Html {cmd pageVar} {
	upvar $pageVar thePage
	GetSite $thePage(site) theSite

	if {[info exist thePage(content)] && $thePage(content) != ""} {
		set name [lindex [split $thePage(content) /] end]
		set fsize [file size [file join $theSite(root) $thePage(content)]]
		if {$fsize < 1024} {
			set size "$fsize [Dict theSite bytes]"
		} elseif {$fsize < 1024*1024} {
			set size "[expr $fsize / 1024] [Dict theSite Kb]"
		} else {
			set size "[format %.1f [expr double($fsize) / (1024.0*1024.0)]] [Dict theSite Mb]"
		}
		cgi_puts "[Dict theSite downloadLabel] [cgi_url $name $thePage(content)] ($size)."
	}
}

# -- Log --
#
# mbl 10/03/00	handled case where no file is specified.
#		added file size.
#
