# Tcl Wiki Server - $Id: image.tcl,v 1.2 2000/08/14 09:55:33 mbl Exp $
# 
# Copyright (c) 1997-99 Michel Beaudouin-Lafon, mbl@daimi.au.dk
# See the file "licence" for information on usage and redistribution
# of this file, and for a DISCLAIMER OF ALL WARRANTIES.

# Wiki page type handler
#	this file must be loaded into the Wiki namespace
#
# ----------------
# image type
# ----------------
#
proc image-EditFormAttr {pageVar} {
	return "enctype=multipart/form-data"
}

proc image-EditForm {pageVar} {
	upvar $pageVar thePage
	GetSite $thePage(site) theSite

	# show picture we're editing
	if [catch {set image $thePage(content)}] {
		set image "undefined"
	}
	cgi_puts "<img src=[dquote_html $image]>"
	br
	
	# file selection field to specify image file name
	cgi_puts "[Dict theSite uploadFileType] [Dict theSite imagePageType]"
	br
	cgi_puts [Dict theSite uploadLabel]
	cgi_file_button content size=40
}

proc image-SavePage {pageVar} {
	upvar $pageVar thePage

	UploadContentFile thePage _images
	return ""
}

proc image-PreviewPage {pageVar} {
	upvar $pageVar thePage

	# ### should clear _preview directory when we're done, or when restarting the server
	UploadContentFile thePage _preview
	return ""
}

proc image-Page2Html {cmd pageVar} {
	upvar $pageVar thePage

	if {[info exist thePage(content)] && $thePage(content) != ""} {
		cgi_puts "<img src=[dquote_html $thePage(content)]>"
	}
}

# -- Log --
#
# mbl 10/03/00	handled case where no file is specified.
#
